package SQ.Columns.Databanks;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;
import com.strategyquant.tradinglib.optimization.WalkForwardMatrixResult;

public class WFMaxProfitByRun extends DatabankColumn {

	public WFMaxProfitByRun() {
		super(L.t("WF Max profit in one run"), DatabankColumn.Decimal2PL, ValueTypes.Maximize, 0, -10000, 10000);
	}

	//------------------------------------------------------------------------

	@Override
	public String getValue(ResultsGroup results, String resultKey, byte direction, byte plType, byte sampleType) throws Exception {
		WalkForwardMatrixResult mwfResult = (WalkForwardMatrixResult) results.mainResult().get(SettingsKeys.WalkForwardResult);
		if(mwfResult==null) return NOT_AVAILABLE;
		
		WalkForwardResult wfResult = mwfResult.getWFResult(results.getBestWFResultKey(), true);		
		return printValue(wfResult.statsSpecial);
	}
}